diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/click/test/ipv4-click-routing-test.cc ns-3.40/src/click/test/ipv4-click-routing-test.cc
--- ns-3.39/src/click/test/ipv4-click-routing-test.cc	2023-07-05 14:23:47.737427000 -0700
+++ ns-3.40/src/click/test/ipv4-click-routing-test.cc	2023-09-27 13:30:37.622839000 -0700
@@ -17,8 +17,6 @@
  * Authors: Lalith Suresh <suresh.lalith@gmail.com>
  */
 
-#ifdef NS3_CLICK
-
 #include "ns3/click-internet-stack-helper.h"
 #include "ns3/ipv4-click-routing.h"
 #include "ns3/ipv4-l3-protocol.h"
@@ -32,6 +30,17 @@
 
 using namespace ns3;
 
+/**
+ * \file
+ * \ingroup click-tests
+ * Click test suite.
+ */
+
+/**
+ * Add Click Internet stack.
+ *
+ * \param node Node.
+ */
 static void
 AddClickInternetStack(Ptr<Node> node)
 {
@@ -40,6 +49,14 @@
     internet.Install(node);
 }
 
+/**
+ * Add network device.
+ *
+ * \param node Node.
+ * \param macaddr MAC address.
+ * \param ipv4addr IPv4 address.
+ * \param ipv4mask IPv4 mask.
+ */
 static void
 AddNetworkDevice(Ptr<Node> node, Mac48Address macaddr, Ipv4Address ipv4addr, Ipv4Mask ipv4mask)
 {
@@ -56,6 +73,10 @@
     ipv4->SetUp(netdev_idx);
 }
 
+/**
+ * \ingroup click-tests
+ * Click interface ID from name test.
+ */
 class ClickIfidFromNameTest : public TestCase
 {
   public:
@@ -102,6 +123,10 @@
     NS_TEST_EXPECT_MSG_EQ(ret, -1, "No eth1 on node");
 }
 
+/**
+ * \ingroup click-tests
+ * Click IP MAC address from name test.
+ */
 class ClickIpMacAddressFromNameTest : public TestCase
 {
   public:
@@ -162,6 +187,10 @@
     delete[] buf;
 }
 
+/**
+ * \ingroup click-tests
+ * Click trivial test.
+ */
 class ClickTrivialTest : public TestCase
 {
   public:
@@ -206,6 +235,10 @@
     delete[] buf;
 }
 
+/**
+ * \ingroup click-tests
+ * Click interface ID from name test.
+ */
 class ClickIfidFromNameTestSuite : public TestSuite
 {
   public:
@@ -216,6 +249,7 @@
         AddTestCase(new ClickIfidFromNameTest, TestCase::QUICK);
         AddTestCase(new ClickIpMacAddressFromNameTest, TestCase::QUICK);
     }
-} g_ipv4ClickRoutingTestSuite;
+};
 
-#endif // NS3_CLICK
+/// Static variable for test initialization
+static ClickIfidFromNameTestSuite g_ipv4ClickRoutingTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/config-store/model/attribute-iterator.cc ns-3.40/src/config-store/model/attribute-iterator.cc
--- ns-3.39/src/config-store/model/attribute-iterator.cc	2023-07-05 14:23:47.741427200 -0700
+++ ns-3.40/src/config-store/model/attribute-iterator.cc	2023-09-27 13:30:37.622839000 -0700
@@ -227,8 +227,7 @@
         for (uint32_t i = 0; i < tid.GetAttributeN(); ++i)
         {
             TypeId::AttributeInformation info = tid.GetAttribute(i);
-            const PointerChecker* ptrChecker =
-                dynamic_cast<const PointerChecker*>(PeekPointer(info.checker));
+            const auto ptrChecker = dynamic_cast<const PointerChecker*>(PeekPointer(info.checker));
             if (ptrChecker != nullptr)
             {
                 NS_LOG_DEBUG("pointer attribute " << info.name);
@@ -246,7 +245,7 @@
                 continue;
             }
             // attempt to cast to an object container
-            const ObjectPtrContainerChecker* vectorChecker =
+            const auto vectorChecker =
                 dynamic_cast<const ObjectPtrContainerChecker*>(PeekPointer(info.checker));
             if (vectorChecker != nullptr)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/config-store/model/model-node-creator.cc ns-3.40/src/config-store/model/model-node-creator.cc
--- ns-3.39/src/config-store/model/model-node-creator.cc	2023-07-05 14:23:47.741427200 -0700
+++ ns-3.40/src/config-store/model/model-node-creator.cc	2023-09-27 13:30:37.622839000 -0700
@@ -41,7 +41,7 @@
 ModelCreator::Add(ModelNode* node)
 {
     GtkTreeIter* parent = m_iters.back();
-    GtkTreeIter* current = g_new(GtkTreeIter, 1);
+    auto current = g_new(GtkTreeIter, 1);
     gtk_tree_store_append(m_treestore, current, parent);
     gtk_tree_store_set(m_treestore, current, COL_NODE, node, -1);
     m_iters.push_back(current);
@@ -58,7 +58,7 @@
 void
 ModelCreator::DoVisitAttribute(Ptr<Object> object, std::string name)
 {
-    ModelNode* node = new ModelNode();
+    auto node = new ModelNode();
     node->type = ModelNode::NODE_ATTRIBUTE;
     node->object = object;
     node->name = name;
@@ -69,7 +69,7 @@
 void
 ModelCreator::DoStartVisitObject(Ptr<Object> object)
 {
-    ModelNode* node = new ModelNode();
+    auto node = new ModelNode();
     node->type = ModelNode::NODE_OBJECT;
     node->object = object;
     Add(node);
@@ -84,7 +84,7 @@
 void
 ModelCreator::DoStartVisitPointerAttribute(Ptr<Object> object, std::string name, Ptr<Object> value)
 {
-    ModelNode* node = new ModelNode();
+    auto node = new ModelNode();
     node->type = ModelNode::NODE_POINTER;
     node->object = object;
     node->name = name;
@@ -102,7 +102,7 @@
                                          std::string name,
                                          const ObjectPtrContainerValue& vector)
 {
-    ModelNode* node = new ModelNode();
+    auto node = new ModelNode();
     node->type = ModelNode::NODE_VECTOR;
     node->object = object;
     node->name = name;
@@ -121,8 +121,8 @@
                                     Ptr<Object> item)
 {
     GtkTreeIter* parent = m_iters.back();
-    GtkTreeIter* current = g_new(GtkTreeIter, 1);
-    ModelNode* node = new ModelNode();
+    auto current = g_new(GtkTreeIter, 1);
+    auto node = new ModelNode();
     node->type = ModelNode::NODE_VECTOR_ITEM;
     node->object = item;
     node->index = index;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/config-store/model/model-typeid-creator.cc ns-3.40/src/config-store/model/model-typeid-creator.cc
--- ns-3.39/src/config-store/model/model-typeid-creator.cc	2023-07-05 14:23:47.741427200 -0700
+++ ns-3.40/src/config-store/model/model-typeid-creator.cc	2023-09-27 13:30:37.622839000 -0700
@@ -38,7 +38,7 @@
 ModelTypeidCreator::Add(ModelTypeid* node)
 {
     GtkTreeIter* parent = m_iters.back();
-    GtkTreeIter* current = g_new(GtkTreeIter, 1);
+    auto current = g_new(GtkTreeIter, 1);
     gtk_tree_store_append(m_treestore, current, parent);
     gtk_tree_store_set(m_treestore, current, COL_TYPEID, node, -1);
     m_iters.push_back(current);
@@ -58,7 +58,7 @@
                                    std::string defaultValue,
                                    uint32_t index)
 {
-    ModelTypeid* node = new ModelTypeid();
+    auto node = new ModelTypeid();
     node->type = ModelTypeid::NODE_ATTRIBUTE;
     node->tid = tid;
     node->name = name;
@@ -71,7 +71,7 @@
 void
 ModelTypeidCreator::StartVisitTypeId(std::string name)
 {
-    ModelTypeid* node = new ModelTypeid();
+    auto node = new ModelTypeid();
     node->type = ModelTypeid::NODE_TYPEID;
     node->tid = TypeId::LookupByName(name);
     Add(node);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/config-store/model/raw-text-config.cc ns-3.40/src/config-store/model/raw-text-config.cc
--- ns-3.39/src/config-store/model/raw-text-config.cc	2023-07-05 14:23:47.741427200 -0700
+++ ns-3.40/src/config-store/model/raw-text-config.cc	2023-09-27 13:30:37.622839000 -0700
@@ -131,7 +131,7 @@
 RawTextConfigSave::Global()
 {
     NS_LOG_FUNCTION(this);
-    for (GlobalValue::Iterator i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
+    for (auto i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
     {
         StringValue value;
         (*i)->GetValue(value);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/config-store/model/xml-config.cc ns-3.40/src/config-store/model/xml-config.cc
--- ns-3.39/src/config-store/model/xml-config.cc	2023-07-05 14:23:47.741427200 -0700
+++ ns-3.40/src/config-store/model/xml-config.cc	2023-09-27 13:30:37.622839000 -0700
@@ -271,7 +271,7 @@
 XmlConfigSave::Global()
 {
     int rc;
-    for (GlobalValue::Iterator i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
+    for (auto i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
     {
         StringValue value;
         (*i)->GetValue(value);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/CMakeLists.txt ns-3.40/src/core/CMakeLists.txt
--- ns-3.39/src/core/CMakeLists.txt	2023-07-05 14:23:47.741427200 -0700
+++ ns-3.40/src/core/CMakeLists.txt	2023-09-27 13:30:37.622839000 -0700
@@ -1,7 +1,5 @@
 # Set lib core link dependencies
-set(libraries_to_link
-    ${CMAKE_THREAD_LIBS_INIT}
-)
+set(libraries_to_link)
 
 set(gsl_test_sources)
 if(${GSL_FOUND})
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/examples/CMakeLists.txt ns-3.40/src/core/examples/CMakeLists.txt
--- ns-3.39/src/core/examples/CMakeLists.txt	2023-07-05 14:23:47.741427200 -0700
+++ ns-3.40/src/core/examples/CMakeLists.txt	2023-09-27 13:30:37.622839000 -0700
@@ -47,7 +47,6 @@
   NAME main-test-sync
   SOURCE_FILES main-test-sync.cc
   LIBRARIES_TO_LINK ${libnetwork}
-                    ${CMAKE_THREAD_LIBS_INIT}
 )
 
 build_lib_example(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/examples/hash-example.cc ns-3.40/src/core/examples/hash-example.cc
--- ns-3.39/src/core/examples/hash-example.cc	2023-07-05 14:23:47.745427100 -0700
+++ ns-3.40/src/core/examples/hash-example.cc	2023-09-27 13:30:37.622839000 -0700
@@ -296,10 +296,10 @@
             return;
         }
 
-        int newPhrases = 0;
+        bool newPhrases = false;
         for (auto& collider : m_hashes)
         {
-            newPhrases += collider.Add(phrase);
+            newPhrases |= collider.Add(phrase);
         }
 
         if (newPhrases)
@@ -352,7 +352,7 @@
         //
         // Number of buckets = k = 2^bits
         long double k32 = 0xFFFFFFFF;
-        long double k64 = static_cast<long double>(0xFFFFFFFFFFFFFFFFULL);
+        auto k64 = static_cast<long double>(0xFFFFFFFFFFFFFFFFULL);
 
         long double n = m_nphrases;
         long double Ec32 = n * (n - 1) / (2 * k32) * (1 - (n - 2) / (3 * k32));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/examples/main-random-variable-stream.cc ns-3.40/src/core/examples/main-random-variable-stream.cc
--- ns-3.39/src/core/examples/main-random-variable-stream.cc	2023-07-05 14:23:47.745427100 -0700
+++ ns-3.40/src/core/examples/main-random-variable-stream.cc	2023-09-27 13:30:37.622839000 -0700
@@ -99,7 +99,7 @@
         data.SetStyle(Gnuplot2dDataset::IMPULSES);
     }
 
-    for (histogram_maptype::const_iterator hi = histogram.begin(); hi != histogram.end(); ++hi)
+    for (auto hi = histogram.begin(); hi != histogram.end(); ++hi)
     {
         data.Add(hi->first, (double)hi->second / (double)probes / precision);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/helper/event-garbage-collector.cc ns-3.40/src/core/helper/event-garbage-collector.cc
--- ns-3.39/src/core/helper/event-garbage-collector.cc	2023-07-05 14:23:47.745427100 -0700
+++ ns-3.40/src/core/helper/event-garbage-collector.cc	2023-09-27 13:30:37.622839000 -0700
@@ -65,7 +65,7 @@
 void
 EventGarbageCollector::Cleanup()
 {
-    for (EventList::iterator iter = m_events.begin(); iter != m_events.end();)
+    for (auto iter = m_events.begin(); iter != m_events.end();)
     {
         if ((*iter).IsExpired())
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/ascii-test.h ns-3.40/src/core/model/ascii-test.h
--- ns-3.39/src/core/model/ascii-test.h	2023-07-05 14:23:47.749427000 -0700
+++ ns-3.40/src/core/model/ascii-test.h	2023-09-27 13:30:37.622839000 -0700
@@ -23,8 +23,7 @@
 #define ASCII_TEST_H
 
 #include "ascii-file.h"
-
-#include "ns3/test.h"
+#include "test.h"
 
 #include <stdint.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/attribute.cc ns-3.40/src/core/model/attribute.cc
--- ns-3.39/src/core/model/attribute.cc	2023-07-05 14:23:47.749427000 -0700
+++ ns-3.40/src/core/model/attribute.cc	2023-09-27 13:30:37.626839000 -0700
@@ -69,7 +69,7 @@
         return value.Copy();
     }
     // attempt to convert to string.
-    const StringValue* str = dynamic_cast<const StringValue*>(&value);
+    const auto str = dynamic_cast<const StringValue*>(&value);
     if (str == nullptr)
     {
         return nullptr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/attribute-construction-list.cc ns-3.40/src/core/model/attribute-construction-list.cc
--- ns-3.39/src/core/model/attribute-construction-list.cc	2023-07-05 14:23:47.749427000 -0700
+++ ns-3.40/src/core/model/attribute-construction-list.cc	2023-09-27 13:30:37.626839000 -0700
@@ -45,7 +45,7 @@
     // vector of values.
     NS_LOG_FUNCTION(this << name << checker << value);
 
-    for (std::list<Item>::iterator k = m_list.begin(); k != m_list.end(); k++)
+    for (auto k = m_list.begin(); k != m_list.end(); k++)
     {
         if (k->checker == checker)
         {
@@ -65,7 +65,7 @@
 AttributeConstructionList::Find(Ptr<const AttributeChecker> checker) const
 {
     NS_LOG_FUNCTION(this << checker);
-    for (CIterator k = m_list.begin(); k != m_list.end(); k++)
+    for (auto k = m_list.begin(); k != m_list.end(); k++)
     {
         NS_LOG_DEBUG("Found " << k->name << " " << k->checker << " " << k->value);
         if (k->checker == checker)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/attribute-container.h ns-3.40/src/core/model/attribute-container.h
--- ns-3.39/src/core/model/attribute-container.h	2023-07-05 14:23:47.749427000 -0700
+++ ns-3.40/src/core/model/attribute-container.h	2023-09-27 13:30:37.626839000 -0700
@@ -20,8 +20,8 @@
 #ifndef ATTRIBUTE_CONTAINER_H
 #define ATTRIBUTE_CONTAINER_H
 
-#include <ns3/attribute-helper.h>
-#include <ns3/string.h>
+#include "attribute-helper.h"
+#include "string.h"
 
 #include <algorithm>
 #include <iterator>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/calendar-scheduler.cc ns-3.40/src/core/model/calendar-scheduler.cc
--- ns-3.39/src/core/model/calendar-scheduler.cc	2023-07-05 14:23:47.749427000 -0700
+++ ns-3.40/src/core/model/calendar-scheduler.cc	2023-09-27 13:30:37.626839000 -0700
@@ -137,8 +137,8 @@
     NS_LOG_LOGIC("insert in bucket=" << bucket);
 
     // insert in bucket list.
-    Bucket::iterator end = m_buckets[bucket].end();
-    for (Bucket::iterator i = m_buckets[bucket].begin(); i != end; ++i)
+    auto end = m_buckets[bucket].end();
+    for (auto i = m_buckets[bucket].begin(); i != end; ++i)
     {
         if (Order(ev.key, i->key))
         {
@@ -267,8 +267,8 @@
     // bucket index of event
     uint32_t bucket = Hash(ev.key.m_ts);
 
-    Bucket::iterator end = m_buckets[bucket].end();
-    for (Bucket::iterator i = m_buckets[bucket].begin(); i != end; ++i)
+    auto end = m_buckets[bucket].end();
+    for (auto i = m_buckets[bucket].begin(); i != end; ++i)
     {
         if (i->key.m_uid == ev.key.m_uid)
         {
@@ -341,7 +341,7 @@
         samples.push_back(DoRemoveNext());
     }
     // put them back
-    for (std::list<Scheduler::Event>::const_iterator i = samples.begin(); i != samples.end(); ++i)
+    for (auto i = samples.begin(); i != samples.end(); ++i)
     {
         DoInsert(*i);
     }
@@ -353,9 +353,9 @@
 
     // finally calculate inter-time average over samples.
     uint64_t totalSeparation = 0;
-    std::list<Scheduler::Event>::const_iterator end = samples.end();
-    std::list<Scheduler::Event>::const_iterator cur = samples.begin();
-    std::list<Scheduler::Event>::const_iterator next = cur;
+    auto end = samples.end();
+    auto cur = samples.begin();
+    auto next = cur;
     next++;
     while (next != end)
     {
@@ -395,8 +395,8 @@
 
     for (uint32_t i = 0; i < oldNBuckets; i++)
     {
-        Bucket::iterator end = oldBuckets[i].end();
-        for (Bucket::iterator j = oldBuckets[i].begin(); j != end; ++j)
+        auto end = oldBuckets[i].end();
+        for (auto j = oldBuckets[i].begin(); j != end; ++j)
         {
             DoInsert(*j);
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/callback.h ns-3.40/src/core/model/callback.h
--- ns-3.39/src/core/model/callback.h	2023-07-05 14:23:47.749427000 -0700
+++ ns-3.40/src/core/model/callback.h	2023-09-27 13:30:37.626839000 -0700
@@ -284,7 +284,7 @@
 
     bool IsEqual(Ptr<const CallbackImplBase> other) const override
     {
-        const CallbackImpl<R, UArgs...>* otherDerived =
+        const auto otherDerived =
             dynamic_cast<const CallbackImpl<R, UArgs...>*>(PeekPointer(other));
 
         if (otherDerived == nullptr)
@@ -324,7 +324,7 @@
         return DoGetTypeid();
     }
 
-    /** \copydoc GetTypeid(). */
+    /** \copydoc GetTypeid() */
     static std::string DoGetTypeid()
     {
         static std::vector<std::string> vec = {GetCppTypeid<R>(), GetCppTypeid<UArgs>()...};
@@ -467,7 +467,8 @@
         auto f = cb.DoPeekImpl()->GetFunction();
 
         CallbackComponentVector components(cb.DoPeekImpl()->GetComponents());
-        components.insert(components.end(), {std::make_shared<CallbackComponent<BArgs>>(bargs)...});
+        components.insert(components.end(),
+                          {std::make_shared<CallbackComponent<std::decay_t<BArgs>>>(bargs)...});
 
         m_impl = Create<CallbackImpl<R, UArgs...>>(
             [f, bargs...](auto&&... uargs) -> R {
@@ -501,8 +502,9 @@
         constexpr bool isComp =
             std::is_function_v<std::remove_pointer_t<T>> || std::is_member_pointer_v<T>;
 
-        CallbackComponentVector components({std::make_shared<CallbackComponent<T, isComp>>(func),
-                                            std::make_shared<CallbackComponent<BArgs>>(bargs)...});
+        CallbackComponentVector components(
+            {std::make_shared<CallbackComponent<T, isComp>>(func),
+             std::make_shared<CallbackComponent<std::decay_t<BArgs>>>(bargs)...});
 
         m_impl = Create<CallbackImpl<R, UArgs...>>(
             [f, bargs...](auto&&... uargs) -> R {
@@ -532,7 +534,7 @@
 
         CallbackComponentVector components(DoPeekImpl()->GetComponents());
         components.insert(components.end(),
-                          {std::make_shared<CallbackComponent<BoundArgs>>(bargs)...});
+                          {std::make_shared<CallbackComponent<std::decay_t<BoundArgs>>>(bargs)...});
 
         cb.m_impl = Create<std::remove_pointer_t<decltype(cb.DoPeekImpl())>>(
             [f, bargs...](auto&&... uargs) mutable {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/config.cc ns-3.40/src/core/model/config.cc
--- ns-3.39/src/core/model/config.cc	2023-07-05 14:23:47.753427000 -0700
+++ ns-3.40/src/core/model/config.cc	2023-09-27 13:30:37.626839000 -0700
@@ -103,7 +103,7 @@
 MatchContainer::Set(std::string name, const AttributeValue& value)
 {
     NS_LOG_FUNCTION(this << name << &value);
-    for (Iterator tmp = Begin(); tmp != End(); ++tmp)
+    for (auto tmp = Begin(); tmp != End(); ++tmp)
     {
         Ptr<Object> object = *tmp;
         // Let ObjectBase::SetAttribute raise any errors
@@ -116,7 +116,7 @@
 {
     NS_LOG_FUNCTION(this << name << &value);
     bool ok = false;
-    for (Iterator tmp = Begin(); tmp != End(); ++tmp)
+    for (auto tmp = Begin(); tmp != End(); ++tmp)
     {
         Ptr<Object> object = *tmp;
         ok |= object->SetAttributeFailSafe(name, value);
@@ -162,7 +162,7 @@
 {
     NS_LOG_FUNCTION(this << name << &cb);
     bool ok = false;
-    for (Iterator tmp = Begin(); tmp != End(); ++tmp)
+    for (auto tmp = Begin(); tmp != End(); ++tmp)
     {
         Ptr<Object> object = *tmp;
         ok |= object->TraceConnectWithoutContext(name, cb);
@@ -187,7 +187,7 @@
 MatchContainer::DisconnectWithoutContext(std::string name, const CallbackBase& cb)
 {
     NS_LOG_FUNCTION(this << name << &cb);
-    for (Iterator tmp = Begin(); tmp != End(); ++tmp)
+    for (auto tmp = Begin(); tmp != End(); ++tmp)
     {
         Ptr<Object> object = *tmp;
         object->TraceDisconnectWithoutContext(name, cb);
@@ -423,8 +423,7 @@
     NS_LOG_FUNCTION(this);
 
     std::string fullPath = "/";
-    for (std::vector<std::string>::const_iterator i = m_workStack.begin(); i != m_workStack.end();
-         i++)
+    for (auto i = m_workStack.begin(); i != m_workStack.end(); i++)
     {
         fullPath += *i + "/";
     }
@@ -549,7 +548,7 @@
                     continue;
                 }
                 // attempt to cast to a pointer checker.
-                const PointerChecker* pChecker =
+                const auto pChecker =
                     dynamic_cast<const PointerChecker*>(PeekPointer(info.checker));
                 if (pChecker != nullptr)
                 {
@@ -572,7 +571,7 @@
                     m_workStack.pop_back();
                 }
                 // attempt to cast to an object vector.
-                const ObjectPtrContainerChecker* vectorChecker =
+                const auto vectorChecker =
                     dynamic_cast<const ObjectPtrContainerChecker*>(PeekPointer(info.checker));
                 if (vectorChecker != nullptr)
                 {
@@ -801,7 +800,7 @@
         std::vector<std::string> m_contexts;
     } resolver = LookupMatchesResolver(path);
 
-    for (Roots::const_iterator i = m_roots.begin(); i != m_roots.end(); i++)
+    for (auto i = m_roots.begin(); i != m_roots.end(); i++)
     {
         resolver.Resolve(*i);
     }
@@ -828,7 +827,7 @@
 {
     NS_LOG_FUNCTION(this << obj);
 
-    for (std::vector<Ptr<Object>>::iterator i = m_roots.begin(); i != m_roots.end(); i++)
+    for (auto i = m_roots.begin(); i != m_roots.end(); i++)
     {
         if (*i == obj)
         {
@@ -867,7 +866,7 @@
         }
     }
     // now, let's reset the initial value of every global value.
-    for (GlobalValue::Iterator i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
+    for (auto i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
     {
         (*i)->ResetInitialValue();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/default-simulator-impl.cc ns-3.40/src/core/model/default-simulator-impl.cc
--- ns-3.39/src/core/model/default-simulator-impl.cc	2023-07-05 14:23:47.753427000 -0700
+++ ns-3.40/src/core/model/default-simulator-impl.cc	2023-09-27 13:30:37.626839000 -0700
@@ -319,7 +319,7 @@
     if (id.GetUid() == EventId::UID::DESTROY)
     {
         // destroy events.
-        for (DestroyEvents::iterator i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
+        for (auto i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
         {
             if (*i == id)
             {
@@ -365,8 +365,7 @@
             return true;
         }
         // destroy events.
-        for (DestroyEvents::const_iterator i = m_destroyEvents.begin(); i != m_destroyEvents.end();
-             i++)
+        for (auto i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
         {
             if (*i == id)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/deprecated.h ns-3.40/src/core/model/deprecated.h
--- ns-3.39/src/core/model/deprecated.h	2023-07-05 14:23:47.753427000 -0700
+++ ns-3.40/src/core/model/deprecated.h	2023-09-27 13:30:37.626839000 -0700
@@ -76,6 +76,13 @@
 
 /**
  * \ingroup core
+ * \def NS_DEPRECATED_3_40
+ * Tag for things deprecated in version ns-3.40.
+ */
+#define NS_DEPRECATED_3_40(msg) NS_DEPRECATED(msg)
+
+/**
+ * \ingroup core
  * \def NS_DEPRECATED_3_39
  * Tag for things deprecated in version ns-3.39.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/double.cc ns-3.40/src/core/model/double.cc
--- ns-3.39/src/core/model/double.cc	2023-07-05 14:23:47.753427000 -0700
+++ ns-3.40/src/core/model/double.cc	2023-09-27 13:30:37.626839000 -0700
@@ -66,7 +66,7 @@
         bool Check(const AttributeValue& value) const override
         {
             NS_LOG_FUNCTION(&value);
-            const DoubleValue* v = dynamic_cast<const DoubleValue*>(&value);
+            const auto v = dynamic_cast<const DoubleValue*>(&value);
             if (v == nullptr)
             {
                 return false;
@@ -103,8 +103,8 @@
         bool Copy(const AttributeValue& source, AttributeValue& destination) const override
         {
             NS_LOG_FUNCTION(&source << &destination);
-            const DoubleValue* src = dynamic_cast<const DoubleValue*>(&source);
-            DoubleValue* dst = dynamic_cast<DoubleValue*>(&destination);
+            const auto src = dynamic_cast<const DoubleValue*>(&source);
+            auto dst = dynamic_cast<DoubleValue*>(&destination);
             if (src == nullptr || dst == nullptr)
             {
                 return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/enum.cc ns-3.40/src/core/model/enum.cc
--- ns-3.39/src/core/model/enum.cc	2023-07-05 14:23:47.753427000 -0700
+++ ns-3.40/src/core/model/enum.cc	2023-09-27 13:30:37.626839000 -0700
@@ -73,7 +73,7 @@
 EnumValue::SerializeToString(Ptr<const AttributeChecker> checker) const
 {
     NS_LOG_FUNCTION(this << checker);
-    const EnumChecker* p = dynamic_cast<const EnumChecker*>(PeekPointer(checker));
+    const auto p = dynamic_cast<const EnumChecker*>(PeekPointer(checker));
     NS_ASSERT(p != nullptr);
     std::string name = p->GetName(m_value);
     return name;
@@ -83,7 +83,7 @@
 EnumValue::DeserializeFromString(std::string value, Ptr<const AttributeChecker> checker)
 {
     NS_LOG_FUNCTION(this << value << checker);
-    const EnumChecker* p = dynamic_cast<const EnumChecker*>(PeekPointer(checker));
+    const auto p = dynamic_cast<const EnumChecker*>(PeekPointer(checker));
     NS_ASSERT(p != nullptr);
     m_value = p->GetValue(value);
     return true;
@@ -150,7 +150,7 @@
 EnumChecker::Check(const AttributeValue& value) const
 {
     NS_LOG_FUNCTION(this << &value);
-    const EnumValue* p = dynamic_cast<const EnumValue*>(&value);
+    const auto p = dynamic_cast<const EnumValue*>(&value);
     if (p == nullptr)
     {
         return false;
@@ -201,8 +201,8 @@
 EnumChecker::Copy(const AttributeValue& source, AttributeValue& destination) const
 {
     NS_LOG_FUNCTION(this << &source << &destination);
-    const EnumValue* src = dynamic_cast<const EnumValue*>(&source);
-    EnumValue* dst = dynamic_cast<EnumValue*>(&destination);
+    const auto src = dynamic_cast<const EnumValue*>(&source);
+    auto dst = dynamic_cast<EnumValue*>(&destination);
     if (src == nullptr || dst == nullptr)
     {
         return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/environment-variable.cc ns-3.40/src/core/model/environment-variable.cc
--- ns-3.39/src/core/model/environment-variable.cc	2023-07-05 14:23:47.753427000 -0700
+++ ns-3.40/src/core/model/environment-variable.cc	2023-09-27 13:30:37.626839000 -0700
@@ -19,7 +19,7 @@
 
 #include "environment-variable.h"
 
-#include "ns3/string.h"
+#include "string.h"
 
 #include <cstdlib>  // std::getenv
 #include <cstring>  // strlen
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/example-as-test.h ns-3.40/src/core/model/example-as-test.h
--- ns-3.39/src/core/model/example-as-test.h	2023-07-05 14:23:47.753427000 -0700
+++ ns-3.40/src/core/model/example-as-test.h	2023-09-27 13:30:37.626839000 -0700
@@ -20,7 +20,7 @@
 #ifndef NS3_EXAMPLE_AS_TEST_SUITE_H
 #define NS3_EXAMPLE_AS_TEST_SUITE_H
 
-#include "ns3/test.h"
+#include "test.h"
 
 #include <string>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/global-value.cc ns-3.40/src/core/model/global-value.cc
--- ns-3.39/src/core/model/global-value.cc	2023-07-05 14:23:47.753427000 -0700
+++ ns-3.40/src/core/model/global-value.cc	2023-09-27 13:30:37.626839000 -0700
@@ -103,7 +103,7 @@
     {
         return;
     }
-    StringValue* str = dynamic_cast<StringValue*>(&value);
+    auto str = dynamic_cast<StringValue*>(&value);
     if (str == nullptr)
     {
         NS_FATAL_ERROR("GlobalValue name=" << m_name << ": input value is not a string");
@@ -127,7 +127,7 @@
     Ptr<AttributeValue> v = m_checker->CreateValidValue(value);
     if (!v)
     {
-        return 0;
+        return false;
     }
     m_currentValue = v;
     return true;
@@ -138,7 +138,7 @@
 {
     NS_LOG_FUNCTION(name << &value);
 
-    for (Iterator i = Begin(); i != End(); i++)
+    for (auto i = Begin(); i != End(); i++)
     {
         if ((*i)->GetName() == name)
         {
@@ -157,7 +157,7 @@
 {
     NS_LOG_FUNCTION(name << &value);
 
-    for (Iterator i = Begin(); i != End(); i++)
+    for (auto i = Begin(); i != End(); i++)
     {
         if ((*i)->GetName() == name)
         {
@@ -193,7 +193,7 @@
 GlobalValue::GetValueByNameFailSafe(std::string name, AttributeValue& value)
 {
     NS_LOG_FUNCTION(name << &value);
-    for (GlobalValue::Iterator gvit = GlobalValue::Begin(); gvit != GlobalValue::End(); ++gvit)
+    for (auto gvit = GlobalValue::Begin(); gvit != GlobalValue::End(); ++gvit)
     {
         if ((*gvit)->GetName() == name)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/int64x64.cc ns-3.40/src/core/model/int64x64.cc
--- ns-3.39/src/core/model/int64x64.cc	2023-07-05 14:23:47.757427200 -0700
+++ ns-3.40/src/core/model/int64x64.cc	2023-09-27 13:30:37.626839000 -0700
@@ -74,7 +74,7 @@
     int64_t hi = absVal.GetHigh();
 
     // Save stream format flags
-    std::size_t precision = static_cast<std::size_t>(os.precision());
+    auto precision = static_cast<std::size_t>(os.precision());
     std::ios_base::fmtflags ff = os.flags();
     const bool floatfield = os.flags() & std::ios_base::floatfield;
     os << std::setw(1) << std::noshowpos;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/integer.cc ns-3.40/src/core/model/integer.cc
--- ns-3.39/src/core/model/integer.cc	2023-07-05 14:23:47.757427200 -0700
+++ ns-3.40/src/core/model/integer.cc	2023-09-27 13:30:37.626839000 -0700
@@ -65,7 +65,7 @@
         bool Check(const AttributeValue& value) const override
         {
             NS_LOG_FUNCTION(&value);
-            const IntegerValue* v = dynamic_cast<const IntegerValue*>(&value);
+            const auto v = dynamic_cast<const IntegerValue*>(&value);
             if (v == nullptr)
             {
                 return false;
@@ -102,8 +102,8 @@
         bool Copy(const AttributeValue& src, AttributeValue& dst) const override
         {
             NS_LOG_FUNCTION(&src << &dst);
-            const IntegerValue* source = dynamic_cast<const IntegerValue*>(&src);
-            IntegerValue* destination = dynamic_cast<IntegerValue*>(&dst);
+            const auto source = dynamic_cast<const IntegerValue*>(&src);
+            auto destination = dynamic_cast<IntegerValue*>(&dst);
             if (source == nullptr || destination == nullptr)
             {
                 return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/length.cc ns-3.40/src/core/model/length.cc
--- ns-3.39/src/core/model/length.cc	2023-07-05 14:23:47.757427200 -0700
+++ ns-3.40/src/core/model/length.cc	2023-09-27 13:30:37.626839000 -0700
@@ -17,9 +17,9 @@
  * Author: Mathew Bielejeski <bielejeski1@llnl.gov>
  */
 
-#include "ns3/length.h"
+#include "length.h"
 
-#include "ns3/log.h"
+#include "log.h"
 
 #include <algorithm>
 #include <array>
